#ifndef FILTERDB_HH
#define FILTERDB_HH

#include "FilterModule.hh"
#include <map>
#include <string>

class FilterDB {
public:
  FilterDB(void);
  explicit FilterDB(const char* file);
  const FilterModule& operator[](const std::string& f) const;
  void reset(void);
  void init(const char* file);
  void insert(const std::string& name, const FilterModule& filter);
  bool empty(void) const;
  bool exists(const std::string& name) const;

private:
  typedef std::map<std::string, FilterModule> FilterMap;
  typedef FilterMap::const_iterator const_map_iter;
  typedef FilterMap::iterator       map_iter;
  FilterMap  mMap;
};

//======================================  inline methods
inline bool
FilterDB::empty(void) const {
    return mMap.empty();
}

inline bool
FilterDB::exists(const std::string& name) const {
    return mMap.find(name) != mMap.end();
}

#endif  // FILTERDB_HH
